HDU 2639:Bone Collector II

来源:互联网 发布:大数据综合实验区 编辑:程序博客网 时间:2024/06/04 18:40

Bone Collector II

查看原题
Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 5247    Accepted Submission(s): 2779


Problem Description
The title of this problem is familiar,isn't it?yeah,if you had took part in the "Rookie Cup" competition,you must have seem this title.If you haven't seen it before,it doesn't matter,I will give you a link:

Here is the link:http://acm.hdu.edu.cn/showproblem.php?pid=2602

Today we are not desiring the maximum value of bones,but the K-th maximum value of the bones.NOTICE that,we considerate two ways that get the same value of bones are the same.That means,it will be a strictly decreasing sequence from the 1st maximum , 2nd maximum .. to the K-th maximum.

If the total number of different values is less than K,just ouput 0.
 

Input
The first line contain a integer T , the number of cases.
Followed by T cases , each case three lines , the first line contain two integer N , V, K(N <= 100 , V <= 1000 , K <= 30)representing the number of bones and the volume of his bag and the K we need. And the second line contain N integers representing the value of each bone. The third line contain N integers representing the volume of each bone.
 

Output
One integer per line representing the K-th maximum of the total value (this number will be less than 231).
 

Sample Input
35 10 21 2 3 4 55 4 3 2 15 10 121 2 3 4 55 4 3 2 15 10 161 2 3 4 55 4 3 2 1
 

Sample Output
1220
 

Author
teddy


题意:在Bone Collector I做这道题基础上解决。在那道题是求最大价值,而这道题则求第k大价值。

解题思路:我们知道01背包的求解过程中,最优解会把上一个最优解替换掉,第几大的值我们都求得过,知识没有保存。所以我们只需把所有前k个值保留下来就行了。

源代码:


#include<cstdio>#include<cstring>#include<algorithm>using namespace std;const int N=1005;int max(int a, int b){return a>b?a:b;}int dp[N][N];int main(){    int t;    scanf("%d",&t);    while(t--)    {        int n,V,k,t=0;        int w[N],v[N],a[N],b[N];        memset(dp,0,sizeof(dp));        memset(a,0,sizeof(a));        memset(b,0,sizeof(b));        scanf("%d%d%d",&n,&V,&k);        for(int i=0;i<n;i++)            scanf("%d",&w[i]);        for(int i=0;i<n;i++)            scanf("%d",&v[i]);        for(int i=0;i<n;i++)        {            for(int j=V;j>=v[i];j--)            {                for(int l=1;l<=k;l++)                {                    a[l]=dp[j][l];                    b[l]=dp[j-v[i]][l]+w[i];                }                int x=1,y=1,z=1;                a[k+1]=b[k+1]=-1;//防治a,b下标相差超过k,那就没意义                while(z<=k&&(x<=k||y<=k))//排序                {                    if(a[x]>b[y])                        dp[j][z]=a[x++];                    else                        dp[j][z]=b[y++];                    if(z==1||dp[j][z]!=dp[j][z-1])                        z++;                }            }        }        printf("%d\n",dp[V][k]);    }    return 0;}